using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;
using System.Data.SqlClient;
using System.Data.SqlTypes;
using System.Xml;
using System.Web.Security;

namespace WebseitenMonitorInstaller
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private const string AdministratorDefaultUserId = "Administrator";
		private const string AdministratorDefaultPasswd = "admin4wsm";
		private const string AdministratorDefaultRole = "admins";

		private System.Windows.Forms.Panel WelcomePanel;
		private System.Windows.Forms.Label WelcomeLabel;
		private System.Windows.Forms.GroupBox MainGroup;
		private System.Windows.Forms.CheckBox UseExistingDb;
		private System.Windows.Forms.ToolTip UseExistingDbToolTip;
		private System.Windows.Forms.Label DBNameLabel;
		private System.Windows.Forms.TextBox DbNameTextBox;
		private System.Windows.Forms.CheckBox ClearExisting;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox InstUserIdTextBox;
		private System.Windows.Forms.TextBox InstPasswdTextBox;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.TextBox InstPasswdRepTextBox;
		private System.Windows.Forms.CheckBox UseInstCredentialsForApp;
		private System.Windows.Forms.RadioButton AppSqlServerAuth;
		private System.Windows.Forms.RadioButton AppWinAuth;
		private System.Windows.Forms.TextBox AppUserIdTextBox;
		private System.Windows.Forms.TextBox AppPasswdTextBox;
		private System.Windows.Forms.TextBox AppPasswdRepTextBox;
		private System.Windows.Forms.Label AppUserIdLabel;
		private System.Windows.Forms.Label AppPasswdLabel;
		private System.Windows.Forms.Label AppPasswdRepLabel;
		private System.Windows.Forms.Label InstUserIdLabel;
		private System.Windows.Forms.Label InstPasswdLabel;
		private System.Windows.Forms.Label InstPasswdRepLabel;
		private System.Windows.Forms.Button CommitButton;
		private System.Windows.Forms.ProgressBar ProgressBar;
		private System.Windows.Forms.Label ProgressLabel;
		private System.Windows.Forms.RadioButton InstSqlServerAuth;
		private System.Windows.Forms.RadioButton InstWinAuth;
		private System.Windows.Forms.TextBox DataSourceTextBox;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.TextBox LogFileNameTextBox;
		private System.Windows.Forms.ComboBox LogLevelComboBox;
		private System.Windows.Forms.TextBox AppUrlBaseTextBox;
		private System.Windows.Forms.Label label5;
		private System.ComponentModel.IContainer components;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			this.UseExistingDbToolTip.SetToolTip(this.UseExistingDb,"Whlen Sie diese Option, falls die erforderlichen Datenbanktabellen in einer vorhandene Datenbank angelegt werden sollen.\nAndernfalls wird eine neue Datenbank erzeugt.");
			this.UseExistingDb.CheckedChanged += new EventHandler(this.UseExistingDb_CheckedChanged);
			this.InstWinAuth.CheckedChanged += new EventHandler(this.InstWinAuth_CheckedChanged);
			this.AppWinAuth.CheckedChanged += new EventHandler(this.AppWinAuth_CheckedChanged);
			this.UseInstCredentialsForApp.CheckedChanged += new EventHandler(this.UseInstCredentialsForApp_CheckedChanged);
			this.CommitButton.Click += new EventHandler(this.CommitButton_Click);
			this.LogLevelComboBox.DropDownStyle = ComboBoxStyle.DropDownList;
			this.LogLevelComboBox.Items.AddRange(new object[] {"ALL","DEBUG","INFO","WARN","ERROR","FATAL","OFF"});
			this.LogLevelComboBox.Text = "INFO";
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.WelcomePanel = new System.Windows.Forms.Panel();
			this.label5 = new System.Windows.Forms.Label();
			this.WelcomeLabel = new System.Windows.Forms.Label();
			this.MainGroup = new System.Windows.Forms.GroupBox();
			this.AppUrlBaseTextBox = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.LogLevelComboBox = new System.Windows.Forms.ComboBox();
			this.label3 = new System.Windows.Forms.Label();
			this.LogFileNameTextBox = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.AppPasswdRepTextBox = new System.Windows.Forms.TextBox();
			this.AppPasswdTextBox = new System.Windows.Forms.TextBox();
			this.AppUserIdTextBox = new System.Windows.Forms.TextBox();
			this.AppPasswdRepLabel = new System.Windows.Forms.Label();
			this.AppPasswdLabel = new System.Windows.Forms.Label();
			this.AppUserIdLabel = new System.Windows.Forms.Label();
			this.AppWinAuth = new System.Windows.Forms.RadioButton();
			this.AppSqlServerAuth = new System.Windows.Forms.RadioButton();
			this.UseInstCredentialsForApp = new System.Windows.Forms.CheckBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.InstPasswdRepLabel = new System.Windows.Forms.Label();
			this.InstPasswdRepTextBox = new System.Windows.Forms.TextBox();
			this.InstPasswdTextBox = new System.Windows.Forms.TextBox();
			this.InstPasswdLabel = new System.Windows.Forms.Label();
			this.InstUserIdTextBox = new System.Windows.Forms.TextBox();
			this.InstUserIdLabel = new System.Windows.Forms.Label();
			this.DataSourceTextBox = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.InstWinAuth = new System.Windows.Forms.RadioButton();
			this.InstSqlServerAuth = new System.Windows.Forms.RadioButton();
			this.ClearExisting = new System.Windows.Forms.CheckBox();
			this.DbNameTextBox = new System.Windows.Forms.TextBox();
			this.DBNameLabel = new System.Windows.Forms.Label();
			this.UseExistingDb = new System.Windows.Forms.CheckBox();
			this.UseExistingDbToolTip = new System.Windows.Forms.ToolTip(this.components);
			this.CommitButton = new System.Windows.Forms.Button();
			this.ProgressBar = new System.Windows.Forms.ProgressBar();
			this.ProgressLabel = new System.Windows.Forms.Label();
			this.WelcomePanel.SuspendLayout();
			this.MainGroup.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// WelcomePanel
			// 
			this.WelcomePanel.Controls.Add(this.label5);
			this.WelcomePanel.Controls.Add(this.WelcomeLabel);
			this.WelcomePanel.Location = new System.Drawing.Point(8, 0);
			this.WelcomePanel.Name = "WelcomePanel";
			this.WelcomePanel.Size = new System.Drawing.Size(472, 56);
			this.WelcomePanel.TabIndex = 0;
			// 
			// label5
			// 
			this.label5.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label5.ForeColor = System.Drawing.Color.Red;
			this.label5.Location = new System.Drawing.Point(8, 32);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(448, 16);
			this.label5.TabIndex = 1;
			this.label5.Text = "Bitte lesen Sie vor der Installation die Hinweise auf der Downloadseite!";
			// 
			// WelcomeLabel
			// 
			this.WelcomeLabel.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.WelcomeLabel.Location = new System.Drawing.Point(8, 8);
			this.WelcomeLabel.Name = "WelcomeLabel";
			this.WelcomeLabel.Size = new System.Drawing.Size(448, 16);
			this.WelcomeLabel.TabIndex = 0;
			this.WelcomeLabel.Text = "Willkommen zur Installation der Webseiten-Monitor Applikation!";
			this.WelcomeLabel.Click += new System.EventHandler(this.WelcomeLabel_Click);
			// 
			// MainGroup
			// 
			this.MainGroup.Controls.Add(this.AppUrlBaseTextBox);
			this.MainGroup.Controls.Add(this.label4);
			this.MainGroup.Controls.Add(this.groupBox3);
			this.MainGroup.Controls.Add(this.groupBox2);
			this.MainGroup.Controls.Add(this.groupBox1);
			this.MainGroup.Controls.Add(this.ClearExisting);
			this.MainGroup.Controls.Add(this.DbNameTextBox);
			this.MainGroup.Controls.Add(this.DBNameLabel);
			this.MainGroup.Controls.Add(this.UseExistingDb);
			this.MainGroup.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.MainGroup.Location = new System.Drawing.Point(8, 56);
			this.MainGroup.Name = "MainGroup";
			this.MainGroup.Size = new System.Drawing.Size(472, 520);
			this.MainGroup.TabIndex = 1;
			this.MainGroup.TabStop = false;
			this.MainGroup.Text = "Daten zur Ausfhrung des Installationsprozesses";
			// 
			// AppUrlBaseTextBox
			// 
			this.AppUrlBaseTextBox.Location = new System.Drawing.Point(136, 488);
			this.AppUrlBaseTextBox.Name = "AppUrlBaseTextBox";
			this.AppUrlBaseTextBox.Size = new System.Drawing.Size(312, 20);
			this.AppUrlBaseTextBox.TabIndex = 8;
			this.AppUrlBaseTextBox.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(12, 492);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(132, 16);
			this.label4.TabIndex = 7;
			this.label4.Text = "Url-Basis der Applikation: ";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.Add(this.LogLevelComboBox);
			this.groupBox3.Controls.Add(this.label3);
			this.groupBox3.Controls.Add(this.LogFileNameTextBox);
			this.groupBox3.Controls.Add(this.label2);
			this.groupBox3.Location = new System.Drawing.Point(8, 408);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(456, 72);
			this.groupBox3.TabIndex = 6;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Logging";
			this.groupBox3.Enter += new System.EventHandler(this.groupBox3_Enter);
			// 
			// LogLevelComboBox
			// 
			this.LogLevelComboBox.Location = new System.Drawing.Point(176, 40);
			this.LogLevelComboBox.Name = "LogLevelComboBox";
			this.LogLevelComboBox.Size = new System.Drawing.Size(120, 21);
			this.LogLevelComboBox.TabIndex = 3;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 44);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(80, 16);
			this.label3.TabIndex = 2;
			this.label3.Text = "Logging Level: ";
			// 
			// LogFileNameTextBox
			// 
			this.LogFileNameTextBox.Location = new System.Drawing.Point(176, 16);
			this.LogFileNameTextBox.Name = "LogFileNameTextBox";
			this.LogFileNameTextBox.Size = new System.Drawing.Size(264, 20);
			this.LogFileNameTextBox.TabIndex = 1;
			this.LogFileNameTextBox.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 20);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(176, 16);
			this.label2.TabIndex = 0;
			this.label2.Text = "Dateiname fr Logging-Ausgabe: ";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.AppPasswdRepTextBox);
			this.groupBox2.Controls.Add(this.AppPasswdTextBox);
			this.groupBox2.Controls.Add(this.AppUserIdTextBox);
			this.groupBox2.Controls.Add(this.AppPasswdRepLabel);
			this.groupBox2.Controls.Add(this.AppPasswdLabel);
			this.groupBox2.Controls.Add(this.AppUserIdLabel);
			this.groupBox2.Controls.Add(this.AppWinAuth);
			this.groupBox2.Controls.Add(this.AppSqlServerAuth);
			this.groupBox2.Controls.Add(this.UseInstCredentialsForApp);
			this.groupBox2.Location = new System.Drawing.Point(8, 248);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(456, 152);
			this.groupBox2.TabIndex = 5;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Datenbank-Authentifikationsdaten fr die Webseiten-Monitor Applikation";
			// 
			// AppPasswdRepTextBox
			// 
			this.AppPasswdRepTextBox.Location = new System.Drawing.Point(176, 112);
			this.AppPasswdRepTextBox.Name = "AppPasswdRepTextBox";
			this.AppPasswdRepTextBox.PasswordChar = '*';
			this.AppPasswdRepTextBox.Size = new System.Drawing.Size(144, 20);
			this.AppPasswdRepTextBox.TabIndex = 8;
			this.AppPasswdRepTextBox.Text = "";
			// 
			// AppPasswdTextBox
			// 
			this.AppPasswdTextBox.Location = new System.Drawing.Point(176, 88);
			this.AppPasswdTextBox.Name = "AppPasswdTextBox";
			this.AppPasswdTextBox.PasswordChar = '*';
			this.AppPasswdTextBox.Size = new System.Drawing.Size(144, 20);
			this.AppPasswdTextBox.TabIndex = 7;
			this.AppPasswdTextBox.Text = "";
			// 
			// AppUserIdTextBox
			// 
			this.AppUserIdTextBox.Location = new System.Drawing.Point(176, 64);
			this.AppUserIdTextBox.Name = "AppUserIdTextBox";
			this.AppUserIdTextBox.Size = new System.Drawing.Size(144, 20);
			this.AppUserIdTextBox.TabIndex = 6;
			this.AppUserIdTextBox.Text = "";
			// 
			// AppPasswdRepLabel
			// 
			this.AppPasswdRepLabel.Location = new System.Drawing.Point(32, 116);
			this.AppPasswdRepLabel.Name = "AppPasswdRepLabel";
			this.AppPasswdRepLabel.Size = new System.Drawing.Size(128, 20);
			this.AppPasswdRepLabel.TabIndex = 5;
			this.AppPasswdRepLabel.Text = "Passwort Wiederholung: ";
			// 
			// AppPasswdLabel
			// 
			this.AppPasswdLabel.Location = new System.Drawing.Point(32, 92);
			this.AppPasswdLabel.Name = "AppPasswdLabel";
			this.AppPasswdLabel.Size = new System.Drawing.Size(68, 16);
			this.AppPasswdLabel.TabIndex = 4;
			this.AppPasswdLabel.Text = "Passwort: ";
			// 
			// AppUserIdLabel
			// 
			this.AppUserIdLabel.Location = new System.Drawing.Point(32, 68);
			this.AppUserIdLabel.Name = "AppUserIdLabel";
			this.AppUserIdLabel.Size = new System.Drawing.Size(64, 16);
			this.AppUserIdLabel.TabIndex = 3;
			this.AppUserIdLabel.Text = "User ID: ";
			// 
			// AppWinAuth
			// 
			this.AppWinAuth.Location = new System.Drawing.Point(176, 40);
			this.AppWinAuth.Name = "AppWinAuth";
			this.AppWinAuth.Size = new System.Drawing.Size(224, 24);
			this.AppWinAuth.TabIndex = 2;
			this.AppWinAuth.Text = "Integrierte Windows Authentifikation";
			// 
			// AppSqlServerAuth
			// 
			this.AppSqlServerAuth.Checked = true;
			this.AppSqlServerAuth.Location = new System.Drawing.Point(8, 40);
			this.AppSqlServerAuth.Name = "AppSqlServerAuth";
			this.AppSqlServerAuth.Size = new System.Drawing.Size(168, 24);
			this.AppSqlServerAuth.TabIndex = 1;
			this.AppSqlServerAuth.TabStop = true;
			this.AppSqlServerAuth.Text = "SqlServer Authentifikation";
			// 
			// UseInstCredentialsForApp
			// 
			this.UseInstCredentialsForApp.Location = new System.Drawing.Point(8, 16);
			this.UseInstCredentialsForApp.Name = "UseInstCredentialsForApp";
			this.UseInstCredentialsForApp.Size = new System.Drawing.Size(432, 16);
			this.UseInstCredentialsForApp.TabIndex = 0;
			this.UseInstCredentialsForApp.Text = "Gleiche Authentifikationsdaten wie fr Installationsprozess verwenden";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.InstPasswdRepLabel);
			this.groupBox1.Controls.Add(this.InstPasswdRepTextBox);
			this.groupBox1.Controls.Add(this.InstPasswdTextBox);
			this.groupBox1.Controls.Add(this.InstPasswdLabel);
			this.groupBox1.Controls.Add(this.InstUserIdTextBox);
			this.groupBox1.Controls.Add(this.InstUserIdLabel);
			this.groupBox1.Controls.Add(this.DataSourceTextBox);
			this.groupBox1.Controls.Add(this.label1);
			this.groupBox1.Controls.Add(this.InstWinAuth);
			this.groupBox1.Controls.Add(this.InstSqlServerAuth);
			this.groupBox1.Location = new System.Drawing.Point(8, 88);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(456, 152);
			this.groupBox1.TabIndex = 4;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Datenbank-Verbindungsdaten fr den Installationsprozess";
			this.groupBox1.Enter += new System.EventHandler(this.groupBox1_Enter);
			// 
			// InstPasswdRepLabel
			// 
			this.InstPasswdRepLabel.Location = new System.Drawing.Point(32, 116);
			this.InstPasswdRepLabel.Name = "InstPasswdRepLabel";
			this.InstPasswdRepLabel.Size = new System.Drawing.Size(128, 16);
			this.InstPasswdRepLabel.TabIndex = 9;
			this.InstPasswdRepLabel.Text = "Passwort Wiederholung:";
			// 
			// InstPasswdRepTextBox
			// 
			this.InstPasswdRepTextBox.Location = new System.Drawing.Point(176, 112);
			this.InstPasswdRepTextBox.Name = "InstPasswdRepTextBox";
			this.InstPasswdRepTextBox.PasswordChar = '*';
			this.InstPasswdRepTextBox.Size = new System.Drawing.Size(144, 20);
			this.InstPasswdRepTextBox.TabIndex = 8;
			this.InstPasswdRepTextBox.Text = "";
			// 
			// InstPasswdTextBox
			// 
			this.InstPasswdTextBox.CausesValidation = false;
			this.InstPasswdTextBox.Location = new System.Drawing.Point(176, 88);
			this.InstPasswdTextBox.Name = "InstPasswdTextBox";
			this.InstPasswdTextBox.PasswordChar = '*';
			this.InstPasswdTextBox.Size = new System.Drawing.Size(144, 20);
			this.InstPasswdTextBox.TabIndex = 7;
			this.InstPasswdTextBox.Text = "";
			// 
			// InstPasswdLabel
			// 
			this.InstPasswdLabel.Location = new System.Drawing.Point(32, 92);
			this.InstPasswdLabel.Name = "InstPasswdLabel";
			this.InstPasswdLabel.Size = new System.Drawing.Size(64, 16);
			this.InstPasswdLabel.TabIndex = 6;
			this.InstPasswdLabel.Text = "Passwort: ";
			// 
			// InstUserIdTextBox
			// 
			this.InstUserIdTextBox.Location = new System.Drawing.Point(176, 64);
			this.InstUserIdTextBox.Name = "InstUserIdTextBox";
			this.InstUserIdTextBox.Size = new System.Drawing.Size(144, 20);
			this.InstUserIdTextBox.TabIndex = 5;
			this.InstUserIdTextBox.Text = "";
			// 
			// InstUserIdLabel
			// 
			this.InstUserIdLabel.Location = new System.Drawing.Point(32, 68);
			this.InstUserIdLabel.Name = "InstUserIdLabel";
			this.InstUserIdLabel.Size = new System.Drawing.Size(64, 16);
			this.InstUserIdLabel.TabIndex = 4;
			this.InstUserIdLabel.Text = "User ID: ";
			// 
			// DataSourceTextBox
			// 
			this.DataSourceTextBox.Location = new System.Drawing.Point(112, 16);
			this.DataSourceTextBox.Name = "DataSourceTextBox";
			this.DataSourceTextBox.Size = new System.Drawing.Size(208, 20);
			this.DataSourceTextBox.TabIndex = 3;
			this.DataSourceTextBox.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 20);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(104, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "SqlServer Instanz: ";
			// 
			// InstWinAuth
			// 
			this.InstWinAuth.Location = new System.Drawing.Point(176, 40);
			this.InstWinAuth.Name = "InstWinAuth";
			this.InstWinAuth.Size = new System.Drawing.Size(216, 24);
			this.InstWinAuth.TabIndex = 1;
			this.InstWinAuth.Text = "Integrierte Windows Authentifikation";
			// 
			// InstSqlServerAuth
			// 
			this.InstSqlServerAuth.Checked = true;
			this.InstSqlServerAuth.Location = new System.Drawing.Point(8, 40);
			this.InstSqlServerAuth.Name = "InstSqlServerAuth";
			this.InstSqlServerAuth.Size = new System.Drawing.Size(168, 24);
			this.InstSqlServerAuth.TabIndex = 0;
			this.InstSqlServerAuth.TabStop = true;
			this.InstSqlServerAuth.Text = "SqlServer Authentifikation";
			// 
			// ClearExisting
			// 
			this.ClearExisting.Checked = true;
			this.ClearExisting.CheckState = System.Windows.Forms.CheckState.Checked;
			this.ClearExisting.Location = new System.Drawing.Point(8, 64);
			this.ClearExisting.Name = "ClearExisting";
			this.ClearExisting.Size = new System.Drawing.Size(416, 24);
			this.ClearExisting.TabIndex = 3;
			this.ClearExisting.Text = "Vorhandene, kollidierende Datenbankelemente vor der Installation lschen";
			// 
			// DbNameTextBox
			// 
			this.DbNameTextBox.Location = new System.Drawing.Point(128, 40);
			this.DbNameTextBox.Name = "DbNameTextBox";
			this.DbNameTextBox.Size = new System.Drawing.Size(176, 20);
			this.DbNameTextBox.TabIndex = 2;
			this.DbNameTextBox.Text = "WEBSEITENMONITOR";
			// 
			// DBNameLabel
			// 
			this.DBNameLabel.Location = new System.Drawing.Point(8, 44);
			this.DBNameLabel.Name = "DBNameLabel";
			this.DBNameLabel.Size = new System.Drawing.Size(120, 16);
			this.DBNameLabel.TabIndex = 1;
			this.DBNameLabel.Text = "Name der Datenbank: ";
			// 
			// UseExistingDb
			// 
			this.UseExistingDb.Location = new System.Drawing.Point(8, 16);
			this.UseExistingDb.Name = "UseExistingDb";
			this.UseExistingDb.Size = new System.Drawing.Size(272, 24);
			this.UseExistingDb.TabIndex = 0;
			this.UseExistingDb.Text = "Tabellen in vorhandener Datenbank anlegen";
			// 
			// UseExistingDbToolTip
			// 
			this.UseExistingDbToolTip.AutoPopDelay = 50000;
			this.UseExistingDbToolTip.InitialDelay = 500;
			this.UseExistingDbToolTip.ReshowDelay = 100;
			// 
			// CommitButton
			// 
			this.CommitButton.Location = new System.Drawing.Point(168, 640);
			this.CommitButton.Name = "CommitButton";
			this.CommitButton.Size = new System.Drawing.Size(128, 24);
			this.CommitButton.TabIndex = 2;
			this.CommitButton.Text = "Installieren";
			// 
			// ProgressBar
			// 
			this.ProgressBar.Location = new System.Drawing.Point(8, 608);
			this.ProgressBar.Name = "ProgressBar";
			this.ProgressBar.Size = new System.Drawing.Size(472, 24);
			this.ProgressBar.TabIndex = 3;
			this.ProgressBar.Visible = false;
			// 
			// ProgressLabel
			// 
			this.ProgressLabel.Location = new System.Drawing.Point(8, 584);
			this.ProgressLabel.Name = "ProgressLabel";
			this.ProgressLabel.Size = new System.Drawing.Size(472, 16);
			this.ProgressLabel.TabIndex = 4;
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(490, 668);
			this.Controls.Add(this.ProgressLabel);
			this.Controls.Add(this.ProgressBar);
			this.Controls.Add(this.CommitButton);
			this.Controls.Add(this.MainGroup);
			this.Controls.Add(this.WelcomePanel);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "MainForm";
			this.Text = "WebseitenMonitorInstaller";
			this.WelcomePanel.ResumeLayout(false);
			this.MainGroup.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		// Event Handlers

		private void WelcomeLabel_Click(object sender, System.EventArgs e)
		{
		
		}

		private void UseExistingDb_CheckedChanged(object sender, EventArgs e) 
		{
			if(!this.UseExistingDb.Checked)
				this.DbNameTextBox.Text = "WEBSEITENMONITOR";
		}

		private void groupBox1_Enter(object sender, System.EventArgs e)
		{
		
		}
		
		private void InstWinAuth_CheckedChanged(object sender, EventArgs e) 
		{
			if(this.InstWinAuth.Checked) 
			{
				this.InstUserIdLabel.Visible = false;
				this.InstPasswdLabel.Visible = false;
				this.InstPasswdRepLabel.Visible = false;
				this.InstUserIdTextBox.Visible = false;
				this.InstPasswdTextBox.Visible = false;
				this.InstPasswdRepTextBox.Visible = false;
			} 
			else 
			{
				this.InstUserIdLabel.Visible = true;
				this.InstPasswdLabel.Visible = true;
				this.InstPasswdRepLabel.Visible = true;
				this.InstUserIdTextBox.Visible = true;
				this.InstPasswdTextBox.Visible = true;
				this.InstPasswdRepTextBox.Visible = true;
			}
		}

		private void AppWinAuth_CheckedChanged(object sender, EventArgs e) 
		{
			if(this.AppWinAuth.Checked) 
			{
				this.AppUserIdLabel.Visible = false;
				this.AppPasswdLabel.Visible = false;
				this.AppPasswdRepLabel.Visible = false;
				this.AppUserIdTextBox.Visible = false;
				this.AppPasswdTextBox.Visible = false;
				this.AppPasswdRepTextBox.Visible = false;
			} 
			else 
			{
				this.AppUserIdLabel.Visible = true;
				this.AppPasswdLabel.Visible = true;
				this.AppPasswdRepLabel.Visible = true;
				this.AppUserIdTextBox.Visible = true;
				this.AppPasswdTextBox.Visible = true;
				this.AppPasswdRepTextBox.Visible = true;
			}
		}

		private void UseInstCredentialsForApp_CheckedChanged(object sender, EventArgs e) 
		{
			if(this.UseInstCredentialsForApp.Checked) 
			{
				this.AppSqlServerAuth.Visible = false;
				this.AppWinAuth.Visible = false;
				this.AppUserIdTextBox.Visible = false;
				this.AppPasswdTextBox.Visible = false;
				this.AppPasswdRepTextBox.Visible = false;
				this.AppUserIdLabel.Visible = false;
				this.AppPasswdLabel.Visible = false;
				this.AppPasswdRepLabel.Visible = false;
			} 
			else 
			{
				this.AppSqlServerAuth.Visible = true;
				this.AppWinAuth.Visible = true;
				if(this.AppSqlServerAuth.Checked) 
				{
					this.AppUserIdTextBox.Visible = true;
					this.AppPasswdTextBox.Visible = true;
					this.AppPasswdRepTextBox.Visible = true;
					this.AppUserIdLabel.Visible = true;
					this.AppPasswdLabel.Visible = true;
					this.AppPasswdRepLabel.Visible = true;
				}
			}
		}


		private void CommitButton_Click(object sender, EventArgs e) 
		{
			// Initiate progress indication
			this.ProgressBar.Visible = true;
			this.ProgressBar.Minimum = 0;
			this.ProgressBar.Maximum = 4;
			this.ProgressBar.Value = 0;
			this.ProgressBar.Step = 1;
			// check user input
			this.ProgressLabel.Text = "Benutzereingaben werden validiert ...";
			if(!this.validateUserInput()) 
			{
				this.ProgressLabel.Text = "";
				this.ProgressBar.Visible = false;
				return;
			}
			this.ProgressLabel.Text = "Benutzereingaben erfolgreich validiert!";
			this.ProgressBar.PerformStep();
			// determine connection string for installation
			this.ProgressLabel.Text = "Db-Connectionstring fr Installation bestimmen ...";
			string instConnString = this.createInstConnString();
			this.ProgressLabel.Text = "";
			this.ProgressBar.PerformStep();
			// set up database
			this.ProgressLabel.Text = "Datenbank wird aufgesetzt ...";
			this.Refresh();
			if(!this.setUpDatabase(instConnString)) 
			{
				this.ProgressLabel.Text = "";
				this.ProgressBar.Visible = false;
				return;
			}
			// adapt configuration files for webpage-monitor application
			this.ProgressLabel.Text = "Konfigurationsdateien werden angepasst ...";
			this.Refresh();
			string appUriPrefix = this.AppUrlBaseTextBox.Text;
			// remove possible final slash from Uri-Prefix
			if(appUriPrefix != null && appUriPrefix.Length > 0 && (appUriPrefix[appUriPrefix.Length - 1] == '/'))
				appUriPrefix = appUriPrefix.Substring(0,appUriPrefix.Length - 1);
			if(!this.adaptConfigFiles(this.LogFileNameTextBox.Text,this.LogLevelComboBox.Text,this.createAppConnString(),appUriPrefix)) 
			{
				this.ProgressLabel.Text = "";
				this.ProgressBar.Visible = false;
				return;
			}

			this.ProgressLabel.Text = "";
			this.ProgressBar.Visible = false;
			MessageBox.Show(this,"Installation war erfolgreich!\n Richten Sie nun bitte den ASP.NET Webserver entsprechend ein.","Erfolgreich",MessageBoxButtons.OK);
			this.Close();

		} // end: method CommitButton_Click

		private string createInstConnString() 
		{
			StringBuilder s = new StringBuilder("Persist Security Info=false;");
			s.Append("Data Source=" + this.DataSourceTextBox.Text + ";");
			if(this.InstWinAuth.Checked) 
			{
				s.Append("Integrated Security=SSPI;");
			}
			else 
			{
				s.Append("Integrated Security=false;");
				s.Append("User ID=" + this.InstUserIdTextBox.Text + ";");
				s.Append("Password=" + this.InstPasswdTextBox.Text + ";");
			}
			if(this.UseExistingDb.Checked) 
			{
				s.Append("Initial Catalog=" + this.DbNameTextBox.Text + ";");
			}
			return s.ToString();
		} // end: method createInstConnString

		private string createAppConnString() 
		{
			StringBuilder s = new StringBuilder("Persist Security Info=false;");
			s.Append("Data Source=" + this.DataSourceTextBox.Text + ";");
			if(this.UseInstCredentialsForApp.Checked) 
			{
				if(this.InstWinAuth.Checked) 
				{
					s.Append("Integrated Security=SSPI;");
				} 
				else 
				{
					s.Append("Integrated Security=false;");
					s.Append("User ID=" + this.InstUserIdTextBox.Text + ";");
					s.Append("Password=" + this.InstPasswdTextBox.Text + ";");
				}
			} 
			else 
			{
				if(this.AppWinAuth.Checked) 
				{
					s.Append("Integrated Security=SSPI;");
				}
				else 
				{
					s.Append("Integrated Security=false;");
					s.Append("User ID=" + this.AppUserIdTextBox.Text + ";");
					s.Append("Password=" + this.AppPasswdTextBox.Text + ";");
				}
			}
			s.Append("Initial Catalog=" + this.DbNameTextBox.Text + ";");
			return s.ToString();
		} // end: method createAppConnString

		private bool validateUserInput() 
		{
			if(this.InstSqlServerAuth.Checked && (this.InstPasswdTextBox.Text != this.InstPasswdRepTextBox.Text)) 
			{
				MessageBox.Show(this,"Datenbank-Passwort fr Installationsprozess wurde nicht bereinstimmend wiederholt.","Eingabeinkonsistenz",MessageBoxButtons.OK);
				return false;
			}
			if(!this.UseInstCredentialsForApp.Checked && this.AppSqlServerAuth.Checked && (this.AppPasswdTextBox.Text != this.AppPasswdRepTextBox.Text)) 
			{
				MessageBox.Show(this,"Datenbank-Passwort fr Webseiten-Monitor Applikation wurde nicht bereinstimmend wiederholt.","Eingabeinkonsistenz",MessageBoxButtons.OK);
				return false;
			}
			try 
			{
				System.IO.FileInfo f = new System.IO.FileInfo(this.LogFileNameTextBox.Text);
			} 
			catch(Exception) 
			{
				MessageBox.Show(this,"Der Dateiname fr das Logfile entspricht keinem zulssigen Dateinamen.","Eingabefehler",MessageBoxButtons.OK);
				return false;
			}
			return true;
		} // end: method validateUserInput

		private bool setUpDatabase(string connString) 
		{
			string position = "0 ";
			IDbConnection con = null;
			try 
			{
				con = new SqlConnection(connString);
				con.Open();
				IDbCommand cmd = null;
				if(this.ClearExisting.Checked) 
				{
					if(!this.UseExistingDb.Checked) 
					{
						// delete whole database and create it as an empty one
						cmd = con.CreateCommand();
						position = " [1] ";
						cmd.CommandText = "USE master";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [2] ";
						cmd.CommandText = "DROP DATABASE " + this.DbNameTextBox.Text;
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [3] ";
						cmd.CommandText = "CREATE DATABASE " + this.DbNameTextBox.Text;
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [4] ";
						cmd.CommandText = "USE " + this.DbNameTextBox.Text;
						cmd.ExecuteNonQuery();
					} 
					else 
					{
						// delete necessary tables in the database;
						cmd = con.CreateCommand();
						position = " [5] ";
						cmd.CommandText = "DROP TABLE UserDefinedMessageObservations";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [6] ";
						cmd.CommandText = "DROP TABLE ObservedDocuments";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [7] ";
						cmd.CommandText = "DROP TABLE ChangeObservations";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [8] ";
						cmd.CommandText = "DROP TABLE Observations";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [9] ";
						cmd.CommandText = "DROP TABLE Categories";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [10] ";
						cmd.CommandText = "DROP TABLE Users";
						cmd.ExecuteNonQuery();
					}
				} 
				else 
				{
					// create database if not intended to use an existing one
					if(!this.UseExistingDb.Checked) 
					{
						cmd = con.CreateCommand();
						position = " [11] ";
						cmd.CommandText = "USE master";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [12] ";
						cmd.CommandText = "CREATE DATABASE " + this.DbNameTextBox.Text;
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [13] ";
						cmd.CommandText = "USE " + this.DbNameTextBox.Text;
						cmd.ExecuteNonQuery();
					}
				}
				// assertion: database exists and is empty - context is at this database
				// create database tables for the webpage monitor application
				cmd = con.CreateCommand();
				position = " [14] ";
				cmd.CommandText = @"
CREATE TABLE Users
(
	Id int IDENTITY(1,1) PRIMARY KEY,
	LoginName nvarchar(15) NOT NULL,
	PwdHash nvarchar(50) NULL,
	Role nvarchar(15) NULL DEFAULT (N'users'),
	CheckCounter int NOT NULL DEFAULT (0)
)";
				cmd.ExecuteNonQuery();
				cmd = con.CreateCommand();
				position = " [15] ";
				cmd.CommandText = @"
CREATE TABLE Categories
(
	Id int IDENTITY(1,1) PRIMARY KEY,
	CategoryName nvarchar(30) NOT NULL,
	Fk_ParentCategory int NULL DEFAULT (null) FOREIGN KEY REFERENCES Categories(Id),
	Fk_Users int NOT NULL FOREIGN KEY REFERENCES Users(Id) ON DELETE CASCADE
)";
				cmd.ExecuteNonQuery();
				cmd = con.CreateCommand();
				position = " [16] ";
				cmd.CommandText = @"
CREATE TABLE Observations
(
	Id int IDENTITY(1,1) PRIMARY KEY,
	Kind int NOT NULL,
	Name nvarchar(50) NOT NULL,
	Url ntext NOT NULL,
	Date datetime NULL DEFAULT (null),
	CheckCounterTimeStamp int NULL DEFAULT (null),
	ChangeState int NOT NULL,
	Fk_Categories int NOT NULL FOREIGN KEY REFERENCES Categories(Id) ON DELETE CASCADE
)";
				cmd.ExecuteNonQuery();
				cmd = con.CreateCommand();
				position = " [17] ";
				cmd.CommandText = @"
CREATE TABLE ChangeObservations
(
	Id int PRIMARY KEY FOREIGN KEY REFERENCES Observations(Id) ON DELETE CASCADE,
	Depth int NOT NULL,
	RootDocument int NULL DEFAULT (null)
)";
				cmd.ExecuteNonQuery();
				cmd = con.CreateCommand();
				position = " [18] ";
				cmd.CommandText = @"
CREATE TABLE ObservedDocuments
(
	Id int IDENTITY(1,1) PRIMARY KEY,
	Kind int NOT NULL,
	State int NOT NULL,
	Title ntext NULL,
	Url ntext NOT NULL,
	HashValue varbinary(100) NULL,
	Fk_DelegateFor int NULL FOREIGN KEY REFERENCES ObservedDocuments(Id),
	Fk_ParentDocument int NULL FOREIGN KEY REFERENCES ObservedDocuments(Id),
	Fk_ChangeObservation int NOT NULL FOREIGN KEY REFERENCES ChangeObservations(Id) ON DELETE CASCADE ON UPDATE CASCADE
)";
				cmd.ExecuteNonQuery();
				cmd = con.CreateCommand();
				position = " [19] ";
				cmd.CommandText = @"
CREATE TABLE UserDefinedMessageObservations
(
	Id int PRIMARY KEY FOREIGN KEY REFERENCES Observations(Id) ON DELETE CASCADE,
	SearchPatternEnabled bit NOT NULL,
	SearchPattern ntext NULL,
	MessageTemplate ntext NULL,
	SelectedElementsPositionDescriptor ntext NULL,
	ResultState int NOT NULL,
	ResultText ntext NULL
)";
				cmd.ExecuteNonQuery();
				// create default administrator account
				cmd = con.CreateCommand();
				position = " [20] ";
				cmd.CommandText = "INSERT INTO Users (LoginName, PwdHash, Role) VALUES(@LoginName,@PwdHash,@Role);";
				cmd.Parameters.Add(new SqlParameter("@LoginName",AdministratorDefaultUserId));
				cmd.Parameters.Add(new SqlParameter("@PwdHash",FormsAuthentication.HashPasswordForStoringInConfigFile(AdministratorDefaultPasswd, "MD5")));
				cmd.Parameters.Add(new SqlParameter("@Role",AdministratorDefaultRole));
				cmd.ExecuteNonQuery();
				// set up application access to webpage-monitor database
				if(!this.UseInstCredentialsForApp.Checked) 
				{
					if(this.AppSqlServerAuth.Checked) 
					{
						// add db login
						cmd = con.CreateCommand();
						position = " [21] ";
						cmd.CommandText = "EXEC sp_addlogin '" + this.AppUserIdTextBox.Text + "', '" + this.AppPasswdTextBox.Text + "', '" + this.DbNameTextBox.Text + "'";
						try 
						{
							cmd.ExecuteNonQuery();
						} 
						catch(SqlException) {
							// if login already exists - SqlException is thrown
						}
						// add db user for login
						cmd = con.CreateCommand();
						position = " [22] ";
						cmd.CommandText = "EXEC sp_adduser '" + this.AppUserIdTextBox.Text + "'";
						cmd.ExecuteNonQuery();
						// set user as owner of created database-tables
						cmd = con.CreateCommand();
						position = " [23] ";
						cmd.CommandText = "EXEC sp_changeobjectowner 'Users', '" + this.AppUserIdTextBox.Text + "'";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [24] ";
						cmd.CommandText = "EXEC sp_changeobjectowner 'Categories', '" + this.AppUserIdTextBox.Text + "'";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [25] ";
						cmd.CommandText = "EXEC sp_changeobjectowner 'Observations', '" + this.AppUserIdTextBox.Text + "'";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [26] ";
						cmd.CommandText = "EXEC sp_changeobjectowner 'ChangeObservations', '" + this.AppUserIdTextBox.Text + "'";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [27] ";
						cmd.CommandText = "EXEC sp_changeobjectowner 'ObservedDocuments', '" + this.AppUserIdTextBox.Text + "'";
						cmd.ExecuteNonQuery();
						cmd = con.CreateCommand();
						position = " [28] ";
						cmd.CommandText = "EXEC sp_changeobjectowner 'UserDefinedMessageObservations', '" + this.AppUserIdTextBox.Text + "'";
						cmd.ExecuteNonQuery();
					}
				}
			}
			catch(Exception e) 
			{
				MessageBox.Show("Es ist ein Fehler beim Datenbankzugriff aufgetreten!" + position + "\n\n" + e.Message,"Fehler",MessageBoxButtons.OK);
				return false;
			} 
			finally 
			{
				try { if(con != null) con.Close();}
				catch(Exception) {}
			}
			return true;
		} // end: method clearExitentDbObjects

		private bool adaptConfigFiles(string logFileName, string logLevel, string dbConnString, string appUriPrefix) 
		{
			try 
			{
				XmlDocument xDoc = new XmlDocument();
				xDoc.Load("./WebseitenMonitor/Web.config");
				// adapt filename to log to
				XmlNode node = xDoc.SelectSingleNode("/configuration/log4net/appender/param[@name=\"File\"]");
				foreach(XmlAttribute attr in node.Attributes) 
					if(attr.LocalName == "value")
						attr.Value = logFileName;
				// adapt log level
				node = xDoc.SelectSingleNode("/configuration/log4net/root/level");
				foreach(XmlAttribute attr in node.Attributes)
					if(attr.LocalName == "value")
						attr.Value = logLevel;
				// adapt database connection string
				node = xDoc.SelectSingleNode("/configuration/appSettings/add[@key=\"AuthenticationDbConnectionString\"]");
				foreach(XmlAttribute attr in node.Attributes)
					if(attr.LocalName == "value")
						attr.Value = dbConnString;
				node = xDoc.SelectSingleNode("/configuration/appSettings/add[@key=\"DbConnectionString\"]");
				foreach(XmlAttribute attr in node.Attributes)
					if(attr.LocalName == "value")
						attr.Value = dbConnString;
				// adapt application uri prefix
				node = xDoc.SelectSingleNode("/configuration/appSettings/add[@key=\"myAppUriAbsolutePathPrefix\"]");
				foreach(XmlAttribute attr in node.Attributes)
					if(attr.LocalName == "value")
						attr.Value = appUriPrefix;
				xDoc.Save("./WebseitenMonitor/Web.config");
			} 
			catch(Exception e) 
			{
				MessageBox.Show(this,"Beim Anpassen der Konfigurationsdatei ist ein Fehler aufgetreten!\n\n" + e.Message);
				return false;
			}
			return true;
		}

		private void groupBox3_Enter(object sender, System.EventArgs e)
		{
		
		} // end: method adaptConfigFiles
	}
}
